<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: ErrorController.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Default
 * @copyright  Copyright (c) 2012 VEC
 */

class ErrorController extends Zend_Controller_Action
{

    public function errorAction ()
    {
        
        $config = Zend_Registry::get('config');
        $errors = $this->_getParam('error_handler');
        $request = $this->getRequest();
        $date = new Zend_Date();
        
        if (empty($errors)) {
            return;
        }
       
        $exception = $errors->exception;
        
        if (GT_PRODUCTION == false) {
            $msg = "Error: " . $exception->getMessage() . "\n";
            $msg .= "Date : " . $date->get('YYYY-MM-dd HH:mm') . "\n";
            $msg .= "Trace: \n" . $exception->getTraceAsString() . "\n";
        } else {
            $msg = "An application error has occurred. Please contact your Administrator.";
            if(Zend_Registry::isRegistered('Zend_Translate')) {
                $translate = Zend_Registry::get('Zend_Translate');
                $msg = $translate->_($msg);
            } 

            error_log($exception->getMessage());
        }
        
        if($request->getParam('module') == 'default' && $request->getParam('controller') == 'draw') {
            Giscuit_Map_Map::drawError($msg);    
        } else {
            echo "<pre>$msg</pre>";            
        }
        
        //ms_ResetErrorList();
        exit;

    }
}

