<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id$
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Mobile
 * @copyright  Copyright (c) 2012 VEC
 */

class Mobile_MapController extends Zend_Controller_Action
{

    public function indexAction()
    {
        $layout = Zend_Layout::getMvcInstance();
        if ($layout instanceof Zend_Layout) {
            $layout->disableLayout();
        }
        
        $settings = Zend_Registry::get('settings');
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
        
        if(! empty($userId)) {
            //Reset settings
            $settings = Zend_Registry::get('settings');
            $settings->historyId = NULL;
            $settings->editingActive = false;
            $settings->historyDateBegin = NULL;
            $settings->historyDateEnd = NULL;
            $settings->querybuilder = NULL;
                        
            $this->view->guest = 'f';
        } else {
            $this->view->guest = 't';
        }
    }
    
    public function settingsAction()
    {
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
        $layerSettingsTable = new Giscuit_Db_Table_LayerSettings();
        
        if(! empty($userId)) {
            //
            $layers = $layerSettingsTable->getPrivateItems();
            $layers = array_merge($layers['layers'], $layers['categories']);
        
            //
            $users = new Giscuit_Db_Table_Users();
            $userData = $users->getItems(array(
                'whereId' => $userId
            ))->current();
            
            //Plugin params
            $pluginParams = array();
            foreach (Zend_Controller_Front::getInstance()->getPlugins() as $plugin) {
                if (! is_subclass_of($plugin, 'Giscuit_Controller_Plugin_Abstract')) {
                    continue;
                }
                $pluginParams = array_merge($pluginParams, $plugin->getParams());
            }
            $pluginParams = (object) $pluginParams;
            
            $result = array(
                'replyCode' => 200,
                'guest' => false,
                'records' => $layers,
                'user' => array(
                    'snap' => $userData->snap ,
                    'netcheck' => $userData->netcheck ,
                    'tooltip' => $userData->tooltip ,
                    'touch_offset' => $userData->touch_offset,
                    'pluginParams' => $pluginParams
                )
            );
        } else {
            $layers = $layerSettingsTable->getPublicItems();
            $layers = array_merge($layers['layers'], $layers['baseLayers']);

            $result = array(
                'replyCode' => 200,
                'guest' => true,
                'records' => $layers,
            );
        }
    
        $this->_helper->json($result);
         
    }
    
}