<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Init.php 3480 2013-06-27 08:48:05Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Plugin
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Controller_Plugin_Abstract
 */
require_once 'Zend/Controller/Plugin/Abstract.php';

/**
 * Initialization plugin
 *  
 * @category   Giscuit
 * @package    Giscuit_Controller
 * @subpackage Plugin
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Controller_Plugin_Init extends Zend_Controller_Plugin_Abstract
{
    //
    public static $languages = array (
        'abk' => 'ab',
        'aar' => 'aa',
        'afr' => 'af',
        'sqi' => 'sq',
        'alb' => 'sq',
        'amh' => 'am',
        'ara' => 'ar',
        'hye' => 'hy',
        'arm' => 'hy',
        'asm' => 'as',
        'aym' => 'ay',
        'aze' => 'az',
        'bak' => 'ba',
        'eus' => 'eu',
        'baq' => 'eu',
        'ben' => 'bn',
        'bih' => 'bh',
        'bis' => 'bi',
        'bre' => 'be',
        'bul' => 'bg',
        'mya' => 'my',
        'bur' => 'my',
        'bel' => 'be',
        'cat' => 'ca',
        'zho' => 'zh',
        'chi' => 'zh',
        'cos' => 'co',
        'cze' => 'cs',
        'ces' => 'cs',
        'dan' => 'da',
        'nla' => 'nl',
        'dut' => 'nl',
        'dzo' => 'dz',
        'eng' => 'en',
        'epo' => 'eo',
        'est' => 'et',
        'fao' => 'fo',
        'fij' => 'fj',
        'fin' => 'fi',
        'fre' => 'fr',
        'fra' => 'fr',
        'fry' => 'fy',
        'glg' => 'gl',
        'kat' => 'ka',
        'geo' => 'ka',
        'ger' => 'de',
        'deu' => 'de',
        'kal' => 'kl',
        'grn' => 'gn',
        'guj' => 'gu',
        'hau' => 'ha',
        'heb' => 'he',
        'hin' => 'hi',
        'hun' => 'hu',
        'isl' => 'is',
        'ice' => 'is',
        'ind' => 'id',
        'iku' => 'iu',
        'ipk' => 'ik',
        'iri' => 'ga',
        'gai' => 'ga',
        'ita' => 'it',
        'jpn' => 'ja',
        'kan' => 'kn',
        'kas' => 'ks',
        'kaz' => 'kk',
        'khm' => 'km',
        'kin' => 'rw',
        'kir' => 'ky',
        'kor' => 'ko',
        'kur' => 'ku',
        'lao' => 'lo',
        'lat' => 'la',
        'lav' => 'lv',
        'lin' => 'ln',
        'lit' => 'lt',
        'mak' => 'mk',
        'mac' => 'mk',
        'mlg' => 'mg',
        'msa' => 'ms',
        'may' => 'ms',
        'mlt' => 'ml',
        'mri' => 'mi',
        'mao' => 'mi',
        'mar' => 'mr',
        'mol' => 'mo',
        'mon' => 'mn',
        'nau' => 'na',
        'nep' => 'ne',
        'nor' => 'no',
        'ori' => 'or',
        'orm' => 'om',
        'pan' => 'pa',
        'per' => 'fa',
        'fas' => 'fa',
        'pol' => 'pl',
        'por' => 'pt',
        'pus' => 'ps',
        'que' => 'qu',
        'roh' => 'rm',
        'rum' => 'ro',
        'ron' => 'ro',
        'run' => 'rn',
        'rus' => 'ru',
        'smo' => 'sm',
        'sag' => 'sg',
        'san' => 'sa',
        'scr' => 'sh',
        'sna' => 'sn',
        'snd' => 'sd',
        'sin' => 'si',
        'ssw' => 'ss',
        'slo' => 'sk',
        'slk' => 'sk',
        'slv' => 'sl',
        'som' => 'so',
        'spa' => 'es',
        'esl' => 'es',
        'sun' => 'su',
        'swa' => 'sw',
        'swe' => 'sv',
        'sve' => 'sv',
        'tgl' => 'tl',
        'tgk' => 'tg',
        'tam' => 'ta',
        'tat' => 'tt',
        'tel' => 'te',
        'tha' => 'th',
        'tib' => 'bo',
        'bod' => 'bo',
        'tir' => 'ti',
        'tso' => 'ts',
        'tsn' => 'tn',
        'tur' => 'tr',
        'tuk' => 'tk',
        'twi' => 'tw',
        'uig' => 'ug',
        'ukr' => 'uk',
        'urd' => 'ur',
        'uzb' => 'uz',
        'vie' => 'vi',
        'vol' => 'vo',
        'wel' => 'cy',
        'cym' => 'cy',
        'wol' => 'wo',
        'xho' => 'xh',
        'yid' => 'yi',
        'yor' => 'yo',
        'zha' => 'za',
        'zul' => 'zu',
    );

    /**
     * Called before Zend_Controller_Front begins evaluating the
     * request against its routes.
     *
     * @param Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function routeStartup (Zend_Controller_Request_Abstract $request)
    {
        $this->initCache();
        
        $this->initHelpers();
        
        $this->initConfig();
        $this->initDb();
        
        $this->initSession($request);
        $this->initUser();
        $this->initSettings();
    }

    /**
     * Called after Zend_Controller_Router exits.
     *
     * Called after Zend_Controller_Front exits from the router.
     *
     * @param  Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function routeShutdown (Zend_Controller_Request_Abstract $request)
    {
        $moduleName = $request->getModuleName();
        $requestUri = $request->getBaseUrl() . rtrim($request->getRequestUri(), '/');
                
        if($requestUri == $request->getBaseUrl() . '/m' 
            || ($requestUri == '' && $this->getBrowserType() == 'mobile')) {
           
            $request->setParam('language', $this->getCurrentLocale($request));
            $request->setModuleName('mobile');
            $request->setControllerName('menu');
            
        } else if($moduleName == '') {
            $config = Zend_Registry::get('config');
            $params = $config->defaultRoute->toArray();
            
            $request->setParam('language', $this->getCurrentLocale($request));
            
            if(! empty($params['module'])) {
                $request->setModuleName($params['module']);
            } else {
                $request->setModuleName('default');
            }
            
            if(! empty($params['controller'])) {
                $request->setControllerName($params['controller']);
            } else {
                $request->setControllerName('news');
            }   

            if(! empty($params['action'])) {
                $request->setActionName($params['action']);
            } else {
                $request->setActionName('index');
            }
            
            $request->setParams($params);
            
            
        } else {
            /*
            if(! file_exists(GT_LAYOUTS_PATH . DIR_SEP . $moduleName . GT_SCRIPT_EXT)) {
                throw new Giscuit_Exception('Invalid module name (' . $moduleName . ')');
            }
            */
        }
        
        $this->initTranslate($request);
    }

    /**
     * Called before Zend_Controller_Front enters its dispatch loop.
     *
     * @param  Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function dispatchLoopStartup (Zend_Controller_Request_Abstract $request)
    {
        $this->initLayout($request);
    }

    /**
     * Called before an action is dispatched by Zend_Controller_Dispatcher.
     *
     * This callback allows for proxy or filter behavior.  By altering the
     * request and resetting its dispatched flag (via
     * {@link Zend_Controller_Request_Abstract::setDispatched() setDispatched(false)}),
     * the current action may be skipped.
     *
     * @param  Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function postDispatch (Zend_Controller_Request_Abstract $request)
    {

    }

    /**
     * Initialize cache
     * 
     * @return void
     */
    public static function initCache ()
    {
        $registry = Zend_Registry::getInstance();
        
        if ($registry->isRegistered('cache')) {
            return;
        }
        
        //Cache
        $frontendOptions = array(
            'lifetime' => 3600 , 
            'automatic_serialization' => true
        );
        
        if(extension_loaded('apc')) {
            $backendOptions = array(
            );
            $backend = 'Apc';            
        } else {
            $backendOptions = array(
                'cache_dir' => GT_TMP_PATH
            );
            $backend = 'File';
        }
                
        $cache = Zend_Cache::factory('Core', $backend, $frontendOptions, $backendOptions);
        $registry->set('cache', $cache);
                
        if (GT_PRODUCTION == false) {
            //Clear cache
               $registry->get('cache')->clean(Zend_Cache::CLEANING_MODE_ALL);
               unset($registry['cache']);
        }
    }

    /**
     * Initialize config
     * 
     * @return void
     */
    public function initConfig ()
    {
        //Run config initialization only once
        if (Zend_Registry::isRegistered('config')) {
            return;
        }
        
        if (Zend_Registry::isRegistered('cache')) {
            
            $cache = Zend_Registry::get('cache');
            $cacheId = md5(GT_APP_PATH) . '_config';
            
            if (! $cache->test($cacheId)) {
                $config = $this->getConfig();
                $cache->save($config, $cacheId);
            } else {
                $config = $cache->load($cacheId);
            }
        } else {
            $config = $this->getConfig();
        }
        
        //Check if Giscuit is installed
        if ($config->installed == 'f') {
            throw new Giscuit_Exception('Giscuit is not installed');
        }
        
        //External programs
        define('GT_PGSQL_BIN_PATH', $config->pgsqlBinPath);
        
        if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
            define('GT_MS_PATH', realpath(GT_APP_PATH . DIR_SEP . '..' . DIR_SEP . '..' . DIR_SEP . '..'));    
        } else {
            define('GT_MS_PATH', '');
        }
                
        if (GT_MS_PATH != '') {
            define('GT_GDAL_BIN_PATH', GT_MS_PATH . DIR_SEP . 'tools' . DIR_SEP . 'gdal-ogr');
            define('GT_GDAL_LIB_PATH', GT_MS_PATH . DIR_SEP . 'Apache' . DIR_SEP . 'cgi-bin');
            define('GT_GDAL_DATA_PATH', GT_MS_PATH . DIR_SEP . 'gdaldata');
            define('GT_PHP_PATH', GT_MS_PATH . DIR_SEP . 'Apache' . DIR_SEP . 'cgi-bin');
        } else {
            define('GT_GDAL_BIN_PATH', '');
            define('GT_GDAL_LIB_PATH', '');
            define('GT_GDAL_DATA_PATH', '');
            define('GT_PHP_PATH', '');
        }
        
        //Set time zone
        date_default_timezone_set($config->timeZone);
        
        //Test in english only
        if (GT_TESTING == true) {
            $config->language = array();
            $config->language->en = 'English';          
        }
        
        //Proxy settings
        if(! empty($config->proxy->host) && ! empty($config->proxy->port)) {
            $defaultOpts = array(
                'http' => array(
                    'method' => 'GET',
                    'header' => "Accept-language: en\r\n",
                    'proxy' => "tcp://{$config->proxy->host}:{$config->proxy->port}",
                    'request_fulluri' => true ,
                )
            );
            
            if (! empty($config->proxy->username) && !empty($config->proxy->password)) {
                $credentials = base64_encode($config->proxy->username . ':' . $config->proxy->password);
                $defaultOpts['http']['header'] .= "Proxy-Authorization: Basic " . $credentials . "\r\n";
            }
            
            stream_context_set_default($defaultOpts);
        }
        
        //SMTP settings
        $smtp = $config->smtp->toArray();
        if($smtp['host'] && $smtp['port']) {
            //
            if(! $smtp['auth']) {
                unset($smtp['auth']);
                unset($smtp['username']);
                unset($smtp['password']);
            }

            //
            if(! $smtp['ssl']) {
                unset($smtp['ssl']);
            }
            
            //
            $tr = new Zend_Mail_Transport_Smtp($smtp['host'], $smtp);
            Zend_Mail::setDefaultTransport($tr);
        }
        
        //
        if(! empty($config->httpPath)) {
            Zend_Controller_Front::getInstance()->setBaseUrl($config->httpPath);
        }
        
        Zend_Registry::set('config', $config);
    }

    /**
     * Get current configuration
     * 
     * @return Zend_Config
     */
    public function getConfig ()
    {
        if (GT_PRODUCTION == true) {
            $section = 'production';
        } else {
            $section = 'staging';
        }
        
        return new Zend_Config_Xml(GT_CONFIG_PATH . DIR_SEP . 'config.xml', $section, array(
            'allowModifications' => true
        ));
    
    }

    /**
     * Initialize database
     * 
     * @return void
     */
    public function initDb ()
    {
        $config = Zend_Registry::get('config');
        
        Giscuit_Controller_Plugin_Init::parseDbParams($config->database);
                
        $db = Zend_Db::factory($config->database);
        $db->setFetchMode(Zend_Db::FETCH_OBJ);
        
        //Cache
        if (Zend_Registry::isRegistered('cache')) {
            Zend_Db_Table_Abstract::setDefaultMetadataCache(Zend_Registry::get('cache'));
        }
        
        //Set a default adapter for all tables
        Zend_Db_Table_Abstract::setDefaultAdapter($db);
        
        /*
        if ($config->dateFormat == 'iso8601') {
            $db->query("SET datestyle TO 'ISO'");
        }
        */
        
        Zend_Registry::set('db', $db);
    }

    /**
     * Initialize translate
     * 
     * @param Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function initTranslate (Zend_Controller_Request_Abstract $request)
    {
        $config = Zend_Registry::get('config');
        
        //Cache
        if (Zend_Registry::isRegistered('cache')) {
            Zend_Translate::setCache(Zend_Registry::get('cache'));
            Zend_Locale::setCache(Zend_Registry::get('cache'));
        }
        
        //Module
        if ($request->getModuleName() == 'admin') {
            $fileName = 'admin';
        } else {
            $fileName = 'default';
        }
        
        //Add languages
        $languages = array_keys($config->language->toArray());
        $translate = new Zend_Translate('tmx', GT_LANGUAGES_PATH . DIR_SEP . $fileName . '.' . $languages[0] . '.tmx', $languages[0]);
        unset($languages[0]);
        foreach($languages as $language) {
            $path = GT_LANGUAGES_PATH . DIR_SEP . $fileName . '.' . $language . '.tmx';
            if(file_exists($path)) {
                $translate->addTranslation($path, $language);
            }
        }
        
        //Set locale
        $locale = $this->getCurrentLocale($request);
        if(! $translate->isAvailable($locale)) {
            if($translate->isAvailable($config->defaultLanguage)) {
                $locale = $config->defaultLanguage; 
            } else {
                 $locale = 'en';
            }    
        } 
        $translate->setLocale($locale);
        
        //Registry
        Zend_Registry::set('Zend_Translate', $translate);
        
        //FIXME:
        Zend_Registry::set('Zend_Locale', new Zend_Locale('en_US'));
    }

    /**
     * Get current locale
     * 
     * @param Zend_Controller_Request_Abstract $request
     * @return string 
     */
    public function getCurrentLocale ($request)
    {
        $get = $request->getParam('language');
        $languages = array_keys(Zend_Registry::get('config')->language->toArray());
                
        //Ows
        if(isset($_GET['LANGUAGE']) && isset(self::$languagesIso639[$_GET['LANGUAGE']])) {
            return self::$languagesIso639[$_GET['LANGUAGE']];
        } else if(isset($_GET['language']) && isset(self::$languagesIso639[$_GET['language']])) {
            return self::$languagesIso639[$_GET['language']];
        } else if(isset($_POST['LANGUAGE']) && isset(self::$languagesIso639[$_POST['LANGUAGE']])) {
            return self::$languagesIso639[$_POST['LANGUAGE']];
        } else if(isset($_POST['language']) && isset(self::$languagesIso639[$_POST['language']])) {
            return self::$languagesIso639[$_POST['language']];
        }
        
        //Get
        if(! empty($get) && $get != 'm') {
            return $get;
        }
        
        //Database
        $userId = Zend_Controller_Action_HelperBroker::getStaticHelper('userId')->direct();
        if(! empty($userId)) {
            $usersTable = new Giscuit_Db_Table_Users();
            return $usersTable->getLanguage($userId);
        }
        
        //Browser
        $locale = new Zend_Locale();
        $browser = $locale->getLanguage();
        if (in_array($browser, $languages)) {
            return $browser; 
        }
        
        //Config
        $config = Zend_Registry::get('config');
        return $config->defaultLanguage;
    }

    /**
     * Initialize layout
     *  
     * @param Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function initLayout (Zend_Controller_Request_Abstract $request)
    {
        $config = Zend_Registry::get('config');
        $layout = Zend_Registry::get('layout');
        
        //Layout
        $layout->getInflector()->setTarget(':fileName');
        $layout->getInflector()->setStaticRule('fileName', $request->getModuleName() . GT_SCRIPT_EXT);
        $layout->controllerName = $request->getControllerName();
        
        //View
        $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
        $viewRenderer->init();
        
        $view = $viewRenderer->view;
        $view->doctype($config->page->doctype);
    }

    /**
     * Initialize settings
     * 
     * @return void
     */
    public function initSettings ()
    {
        $settings = new Zend_Session_Namespace('settings');
        Zend_Registry::set('settings', $settings);
    
    }

    /**
     * Initialize current user
     * 
     * @return void
     */
    public function initUser ()
    {
        //FIXME: Avoid multiple user initializations while unit testing
        if(Zend_Registry::isRegistered('user')) {
            return;
        }
        
        $config = Zend_Registry::get('config');
        $db = Zend_Registry::get('db');
        $auth = Zend_Auth::getInstance();
        
        if ($auth->hasIdentity()) {
            $user = $auth->getIdentity();
            
            //FIXME:
            if(! isset($user->group)) {
                $user = new ArrayObject();
                $user->group = 'guest';    
            }
        } else {
            $user = new ArrayObject();
            $user->group = 'guest';
        }

        if ($config->dateFormat == 'german') {
            define('GT_DATE_STYLE_DB', 'DD.MM.YYYY');
            define('GT_DATE_STYLE_PHP', 'dd.MM.yyyy');
            define('GT_DATE_STYLE_YUI', '%d.%m.%Y');
            define('GT_DATE_STYLE_JS', 'dd.mm.yyyy');

            if($user->group != 'guest') {
                define('GT_DATETIME_STYLE_DB', 'DD.MM.YYYY HH24:MI');
                define('GT_DATETIME_STYLE_PHP', 'dd.MM.yyyy HH:mm');
                define('GT_DATETIME_STYLE_YUI', '%d.%m.%Y %H:%M');
                define('GT_DATETIME_STYLE_JS', 'dd.mm.yyyy HH:MM');
            }
            
            $db->query("SET datestyle TO 'German'");
            
        }  else if ($config->dateFormat == 'sqlMdy') {
            define('GT_DATE_STYLE_DB', 'MM/DD/YYYY');
            define('GT_DATE_STYLE_PHP', 'MM/dd/yyyy');
            define('GT_DATE_STYLE_YUI', '%m/%d/%Y');
            define('GT_DATE_STYLE_JS', 'mm/dd/yyyy');
            
            if($user->group != 'guest') {
                define('GT_DATETIME_STYLE_DB', 'MM/DD/YYYY HH24:MI');
                define('GT_DATETIME_STYLE_PHP', 'MM/dd/yyyy HH:mm');
                define('GT_DATETIME_STYLE_YUI', '%m/%d/%Y %H:%M');
                define('GT_DATETIME_STYLE_JS', 'mm/dd/yyyy HH:MM');
            }
            
            $db->query("SET datestyle TO 'SQL, MDY'");
            
        } else {
            define('GT_DATE_STYLE_DB', 'YYYY-MM-DD');
            define('GT_DATE_STYLE_PHP', 'yyyy-MM-dd');
            define('GT_DATE_STYLE_YUI', '%Y-%m-%d');
            define('GT_DATE_STYLE_JS', 'yyyy-mm-dd');
            
            if($user->group != 'guest') {
                define('GT_DATETIME_STYLE_DB', 'YYYY-MM-DD HH24:MI');
                define('GT_DATETIME_STYLE_PHP', 'yyyy-MM-dd HH:mm');
                define('GT_DATETIME_STYLE_YUI', '%Y-%m-%d %H:%M');
                define('GT_DATETIME_STYLE_JS', 'yyyy-mm-dd HH:MM');
            }
            
            $db->query("SET datestyle TO 'ISO'");
        }
        
        if($user->group == 'guest') {
            define('GT_DATETIME_STYLE_DB', GT_DATE_STYLE_DB);
            define('GT_DATETIME_STYLE_PHP', GT_DATE_STYLE_PHP);
            define('GT_DATETIME_STYLE_YUI', GT_DATE_STYLE_YUI);
            define('GT_DATETIME_STYLE_JS', GT_DATE_STYLE_JS);
            
            $db->query("SET timezone TO '{$config->timeZone}'");
        } else {
            if(! empty($user->timezone)) {
                $db->query("SET timezone TO '{$user->timezone}'");
            } else {
                $db->query("SET timezone TO '{$config->timeZone}'");
            }           
        }
                
        Zend_Registry::set('user', $user);
    }

    /**
     * Initialize helpers
     * 
     * @return void
     */
    public function initHelpers ()
    {
        //Helpers
        Zend_Controller_Action_HelperBroker::addPrefix('Giscuit_Controller_Action_Helper');

        //View
        $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');
        $viewRenderer->initView();
        $viewRenderer->view->addHelperPath(GT_LIBRARY_PATH . DIR_SEP . 'Giscuit' . DIR_SEP . 'View' . DIR_SEP . 'Helper', 'Giscuit_View_Helper');
        Zend_Controller_Action_HelperBroker::addPath('Giscuit/Controller/Action/Helper/', 'Giscuit_Controller_Action_Helper');
    
    }

    /**
     * Initialize session
     * 
     * @param Zend_Controller_Request_Abstract $request
     * @return void
     */
    public function initSession (Zend_Controller_Request_Abstract $request)
    {
        //Skip session creation for public wms and wfs
        $uri = $request->getRequestUri();
        if(stristr($uri, 'wms/public') 
            || stristr($uri, 'wfs/public')
            || stristr($uri, 'wms/tilecache')) {
            return;
        }
        
        $config = Zend_Registry::get('config');
        
        $sessionConfig = array(
            'name' => 'sessions' ,
            'schema' => $config->database->schema , 
            'primary' => 'id' , 
            'modifiedColumn' => 'modified' , 
            'dataColumn' => 'data' , 
            'lifetimeColumn' => 'lifetime'
        );
        
        $sessionTable = new Giscuit_Session_SaveHandler_DbTable($sessionConfig);
        Zend_Registry::set('sessionTable', $sessionTable);        
        
        Zend_Session::setSaveHandler($sessionTable);
                        
        Zend_Session::setOptions(array(
            'use_only_cookies' => 0 ,
            'gc_probability' => 1 ,
            'gc_maxlifetime' => 3600
        ));
        
        Zend_Session::start();
    }
    
    public function getBrowserType()
    {
        if(GT_TESTING == false) {
            if(isset($_SERVER['HTTP_USER_AGENT'])) {
                $useragent = $_SERVER['HTTP_USER_AGENT'];    
            } else {
                $useragent = '';
            }
        
            if(preg_match('/android|avantgo|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od|ad)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|e\-|e\/|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\-|2|g)|yas\-|your|zeto|zte\-/i',substr($useragent,0,4))) {
                return 'mobile';
            } else {
                return 'desktop';
            }
        } else {
            return 'desktop';
        }
    }
    
    public static function getDbConnectionString ()
    {
        $config = Zend_Registry::get('config');
        
        $connectionString = 'user=' . $config->database->params->username;
        $connectionString .= ' password=' . $config->database->params->password;
        if (! empty($config->database->params->host)) {
            $connectionString .= ' host=' . $config->database->params->host;
            
            if (! empty($config->database->params->port)) {
                $connectionString .= ' port=' . $config->database->params->port;
            }
        }
        $connectionString .= ' dbname=' . $config->database->params->dbname;
        
        return $connectionString;
    }
    
    public static function parseDbParams($database)
    {
        if(empty($database->params->host)) {
            unset($database->params->host);
        }
        
        if(empty($database->params->port)) {
            unset($database->params->port);
        }    
    }
    
}


