<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: RastercutManage.php 3438 2013-06-12 12:42:26Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Download raster statistics form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_RastercutManage extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $settings = Zend_Registry::get('settings');
        $config = Zend_Registry::get('config');

        //Date begin
        if(! empty($settings->rastercutDateBegin)) {
            $dateBeginValue = $settings->rastercutDateBegin;
        } else {
            $date = new Zend_Date();
            $dateBeginValue = $date->toString(GT_DATE_STYLE_PHP);
        }
        $this->addElement('date', 'dateBegin', array(
            'label' => 'dateBegin' , 
            'attribs' => array(
                'id' => 'gtRastercutDateBeginId'
            ) ,
            'value' => $dateBeginValue
        ));
        
        //Date end
        if(! empty($settings->rastercutDateEnd)) {
            $dateEndValue = $settings->rastercutDateEnd;
        } else {
            $dateEndValue = NULL;
        }
        $this->addElement('date', 'dateEnd', array(
            'label' => 'dateEnd' , 
            'attribs' => array(
                'id' => 'gtRastercutDateEndId'
            ) ,
            'value' => $dateEndValue
        ));
        
        //Submit
        $this->addElement('button', 'submit', array(
            'ignore' => true , 
            'label' => 'submit' , 
            'attribs' => array(
                'id' => 'gtRastercutManageSubmit'
            ) ,
            'decorators' => array(
                'ViewHelper'
            )
        ));
        
        //Clear
        $this->addElement('button', 'clear', array(
            'ignore' => true , 
            'label' => 'clear' , 
            'attribs' => array(
                'id' => 'gtRastercutManageClear'
            ) ,
            'decorators' => array(
                'ViewHelper'
            )
        ));

    }
}