<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Point.php 3437 2013-06-12 11:41:35Z vlad.bruma $
 * @category   Giscuit
 * @package    Giscuit_Map
 * @subpackage Layer
 * @copyright  Copyright (c) 2012 VEC
 */
/**
 * @see Giscuit_Map_Layer_Vector
 */
require_once 'Giscuit/Map/Layer/Vector.php';

/**
 * Class for abstract mapserver vector point layer object
 *
 * @category   Giscuit
 * @package    Giscuit_Map
 * @subpackage Layer
 * @copyright  Copyright (c) 2012 VEC
 */
abstract class Giscuit_Map_Layer_Point extends Giscuit_Map_Layer_Vector
{
    
    /**
     * Class constructor
     *
     * @param mixed $map Map object
     * @param array $settings Settings
     * @return void
     */
    public function __construct ($map, $settings)
    {
        parent::__construct($map, $settings);
    
        $this->setCluster();
    
    }
    
    public function setCluster () 
    {
        
        if (isset($this->_settings['cluster_active']) && $this->_settings['cluster_active'] == 't') {
                
            if (! empty($this->_settings['cluster_maxdistance'])) {
                $this->cluster->maxdistance = $this->_settings['cluster_maxdistance'];
            }
                
            if (! empty($this->_settings['cluster_buffer'])) {
                $this->cluster->buffer = $this->_settings['cluster_buffer'];
            }
                
            $this->cluster->region = $this->_settings['cluster_region'];
        
            if (! empty($this->_settings['cluster_group'])) {
                $groupExpr = "('[{$this->_settings['cluster_group']}]')";
                $this->cluster->setGroup($groupExpr);
            }
                
            if (! empty($this->_settings['cluster_filter'])) {
                $this->cluster->setFilter($this->_settings['cluster_filter']);
            }
            
        }
        
    }
}