/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Picker.js 2784 2012-06-22 15:39:19Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
/**
 * Class: Giscuit.Color.Picker
 * 
 */
Giscuit.Color.Picker = function(namespace) {
    this.namespace = namespace;
    this._colorPicker = null;
    this.colorButton = null;
    this.colorMenu = null;
};

Giscuit.Color.Picker.prototype.destroy = function () {
    YAHOO.util.Event.purgeElement(this._colorPicker, true);
    
    //this.colorMenu.destroy();
    this.colorMenu = null;
    
    this.colorButton.destroy();
    this.colorButton = null;
};

Giscuit.Color.Picker.prototype.render = function () {
    //Create a Menu instance to house the ColorPicker instance
    this.colorMenu = new YAHOO.widget.Menu(this.namespace + 'ColorMenu');

    //Create a Button instance of type "split"
    this.colorButton = new YAHOO.widget.Button({
        type: 'split',
        id: this.namespace + 'ColorButton',
        menu: this.colorMenu,
        label: '<em id="gt-picker-current-color"></em>',
        container: this.namespace + 'ColorContainer'
    });

    this.colorButton.on('appendTo', function () {

        this.colorMenu.setBody("&#32;");
        this.colorMenu.body.id = this.namespace + 'ColorPickerContainer';
        this.colorMenu.render(this.colorButton.get('container'));

        //Set current color
        YAHOO.util.Dom.setStyle("gt-picker-current-color", 'backgroundColor', YAHOO.util.Dom.get(this.namespace + "ColorValue").value);
    },
    null, this);

    this.colorButton.on('option', this.change, null, this);
};

Giscuit.Color.Picker.prototype.list = {
    '#111111': 'Obsidian',
    '#2D2D2D': 'Dark Gray',
    '#434343': 'Shale',
    '#5B5B5B': 'Flint',
    '#737373': 'Gray',
    '#8B8B8B': 'Concrete',
    '#A2A2A2': 'Gray',
    '#B9B9B9': 'Titanium',
    '#000000': 'Black',
    '#D0D0D0': 'Light Gray',
    '#E6E6E6': 'Silver',
    '#FFFFFF': 'White',
    '#BFBF00': 'Pumpkin',
    '#FFFF00': 'Yellow',
    '#FFFF40': 'Banana',
    '#FFFF80': 'Pale Yellow',
    '#FFFFBF': 'Butter',
    '#525330': 'Raw Siena',
    '#898A49': 'Mildew',
    '#AEA945': 'Olive',
    '#7F7F00': 'Paprika',
    '#C3BE71': 'Earth',
    '#E0DCAA': 'Khaki',
    '#FCFAE1': 'Cream',
    '#60BF00': 'Cactus',
    '#80FF00': 'Chartreuse',
    '#A0FF40': 'Green',
    '#C0FF80': 'Pale Lime',
    '#DFFFBF': 'Light Mint',
    '#3B5738': 'Green',
    '#668F5A': 'Lime Gray',
    '#7F9757': 'Yellow',
    '#407F00': 'Clover',
    '#8A9B55': 'Pistachio',
    '#B7C296': 'Light Jade',
    '#E6EBD5': 'Breakwater',
    '#00BF00': 'Spring Frost',
    '#00FF80': 'Pastel Green',
    '#40FFA0': 'Light Emerald',
    '#80FFC0': 'Sea Foam',
    '#BFFFDF': 'Sea Mist',
    '#033D21': 'Dark Forrest',
    '#438059': 'Moss',
    '#7FA37C': 'Medium Green',
    '#007F40': 'Pine',
    '#8DAE94': 'Yellow Gray Green',
    '#ACC6B5': 'Aqua Lung',
    '#DDEBE2': 'Sea Vapor',
    '#00BFBF': 'Fog',
    '#00FFFF': 'Cyan',
    '#40FFFF': 'Turquoise Blue',
    '#80FFFF': 'Light Aqua',
    '#BFFFFF': 'Pale Cyan',
    '#033D3D': 'Dark Teal',
    '#347D7E': 'Gray Turquoise',
    '#609A9F': 'Green Blue',
    '#007F7F': 'Seaweed',
    '#96BDC4': 'Green Gray',
    '#B5D1D7': 'Soapstone',
    '#E2F1F4': 'Light Turquoise',
    '#0060BF': 'Summer Sky',
    '#0080FF': 'Sky Blue',
    '#40A0FF': 'Electric Blue',
    '#80C0FF': 'Light Azure',
    '#BFDFFF': 'Ice Blue',
    '#1B2C48': 'Navy',
    '#385376': 'Biscay',
    '#57708F': 'Dusty Blue',
    '#00407F': 'Sea Blue',
    '#7792AC': 'Sky Blue Gray',
    '#A8BED1': 'Morning Sky',
    '#DEEBF6': 'Vapor',
    '#0000BF': 'Deep Blue',
    '#0000FF': 'Blue',
    '#4040FF': 'Cerulean Blue',
    '#8080FF': 'Evening Blue',
    '#BFBFFF': 'Light Blue',
    '#212143': 'Deep Indigo',
    '#373E68': 'Sea Blue',
    '#444F75': 'Night Blue',
    '#00007F': 'Indigo Blue',
    '#585E82': 'Dockside',
    '#8687A4': 'Blue Gray',
    '#D2D1E1': 'Light Blue Gray',
    '#6000BF': 'Neon Violet',
    '#8000FF': 'Blue Violet',
    '#A040FF': 'Violet Purple',
    '#C080FF': 'Violet Dusk',
    '#DFBFFF': 'Pale Lavender',
    '#302449': 'Cool Shale',
    '#54466F': 'Dark Indigo',
    '#655A7F': 'Dark Violet',
    '#40007F': 'Violet',
    '#726284': 'Smoky Violet',
    '#9E8FA9': 'Slate Gray',
    '#DCD1DF': 'Violet White',
    '#BF00BF': 'Royal Violet',
    '#FF00FF': 'Fuchsia',
    '#FF40FF': 'Magenta',
    '#FF80FF': 'Orchid',
    '#FFBFFF': 'Pale Magenta',
    '#4A234A': 'Dark Purple',
    '#794A72': 'Medium Purple',
    '#936386': 'Cool Granite',
    '#7F007F': 'Purple',
    '#9D7292': 'Purple Moon',
    '#C0A0B6': 'Pale Purple',
    '#ECDAE5': 'Pink Cloud',
    '#BF005F': 'Hot Pink',
    '#FF007F': 'Deep Pink',
    '#FF409F': 'Grape',
    '#FF80BF': 'Electric Pink',
    '#FFBFDF': 'Pink',
    '#451528': 'Purple Red',
    '#823857': 'Purple Dino',
    '#A94A76': 'Purple Gray',
    '#7F003F': 'Rose',
    '#BC6F95': 'Antique Mauve',
    '#D8A5BB': 'Cool Marble',
    '#F7DDE9': 'Pink Granite',
    '#C00000': 'Apple',
    '#FF0000': 'Fire Truck',
    '#FF4040': 'Pale Red',
    '#FF8080': 'Salmon',
    '#FFC0C0': 'Warm Pink',
    '#441415': 'Sepia',
    '#82393C': 'Rust',
    '#AA4D4E': 'Brick',
    '#800000': 'Brick Red',
    '#BC6E6E': 'Mauve',
    '#D8A3A4': 'Shrimp Pink',
    '#F8DDDD': 'Shell Pink',
    '#BF5F00': 'Dark Orange',
    '#FF7F00': 'Orange',
    '#FF9F40': 'Grapefruit',
    '#FFBF80': 'Canteloupe',
    '#FFDFBF': 'Wax',
    '#482C1B': 'Dark Brick',
    '#855A40': 'Dirt',
    '#B27C51': 'Tan',
    '#7F3F00': 'Nutmeg',
    '#C49B71': 'Mustard',
    '#E1C4A8': 'Pale Tan',
    '#FDEEE0': 'Marble'
};

Giscuit.Color.Picker.prototype.change = function (event) {

    var Dom = YAHOO.util.Dom,
        Event = YAHOO.util.Event,
        Lang = YAHOO.lang;

    var picker = document.createElement('div');
    picker.className = 'yui-toolbar-colors';
    picker.style.display = 'block';
    
    this.colorMenu.body.appendChild(picker);
    this._colorPicker = picker;
    
    var html = '';

    for (var i in this.list) {
        if (YAHOO.lang.hasOwnProperty(this.list, i)) {
            html += '<a style="background-color: ' + i + '" href="#">' + i.replace('#', '') + '</a>';
        }
    }
    html += '<span><em>X</em><strong></strong></span>';

    picker.innerHTML = html;

    //On mouse over
    Event.on(picker, 'mouseover', function (ev) {
        var picker = this._colorPicker;
        var em = picker.getElementsByTagName('em')[0];
        var strong = picker.getElementsByTagName('strong')[0];
        var tar = Event.getTarget(ev);
        if (tar.tagName.toLowerCase() == 'a') {
            em.style.backgroundColor = tar.style.backgroundColor;
            strong.innerHTML = this.list['#' + tar.innerHTML] + '<br>' + tar.innerHTML;
        }
    },
    null, this);

    //On click
    Event.on(picker, 'mousedown', function (ev) {
        Event.stopEvent(ev);

        var tar = Event.getTarget(ev);
        if (tar.tagName.toLowerCase() == 'a') {
            sColor = '#' + tar.innerHTML;

            YAHOO.util.Dom.setStyle("gt-picker-current-color", "backgroundColor", sColor);
            YAHOO.util.Dom.get(this.namespace + "ColorValue").value = sColor;

            this.colorMenu.hide();
        }
    },
    null, this);

    Event.on(picker, 'focus', function (ev) {
        Event.stopEvent(ev);
    });

    Event.on(picker, 'click', function (ev) {
        Event.stopEvent(ev);
    });

    this.colorButton.unsubscribe("option", this.change);
};