/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Osm.js 3536 2014-04-07 12:30:24Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
/**
 * Class : Giscuit.Layer.Osm
 * 
 */
Giscuit.Layer.Osm = OpenLayers.Class(OpenLayers.Layer.XYZ, {
    initialize: function(name, url, options) {
        //Required
        this.visibility = false;
        
        var newArguments = [];
        newArguments.push(name, url, options);
        
        //Name
        newArguments[0] = 'Osm';
        
        //Url
        newArguments[1] = [
            'http://a.tile.openstreetmap.org/${z}/${x}/${y}.png',
            'http://b.tile.openstreetmap.org/${z}/${x}/${y}.png',
            'http://c.tile.openstreetmap.org/${z}/${x}/${y}.png'
        ];
        
        //Options
        newArguments[2] = {
            attribution: "Data CC-By-SA by <a href='http://openstreetmap.org/'>OpenStreetMap</a>",
            sphericalMercator: true,
            wrapDateLine: true,
            tileOptions: null,
            resolutions: gt.map.resolutions,
            minResolution: gt.map.resolutions[gt.map.resolutions.length - 1]
        };
        
        OpenLayers.Layer.XYZ.prototype.initialize.apply(this, newArguments);
        
    },    
    CLASS_NAME: "Giscuit.Layer.Osm"
});